﻿init python:
    def return_mouse_pos():
        return renpy.get_mouse_pos()
    class inventory_class:
        def __init__(self, cash = 0, items = [], markup = 1.0, bags = [[4, "Pockets"], [12, "Backpack"]]):
            self.cash = cash
            self.items = items
            self.markup = markup

            self.bags = bags
            b = 0
            for i in self.bags:
                b += i[0]
            for i in range(b - len(self.items)):
                self.items.append(None)
            self.current_bag = [0, self.bags[0][0], 0]

            self.uniqueID = []
            self.holding = None

            self.bag_x = 0
        def dragged(self, drags, drop):
            self.bag_x = drags[0].x
            renpy.restart_interaction()

        def set_bag(self, index):
            start = 0
            for n, i in enumerate(self.bags):
                if n < index:
                    start += i[0]
            end = start + self.bags[index][0]
            self.current_bag = [start, end, index]
        def add_bag(self, bag):
            self.bags.append(bag)
            for i in range(bag[0]):
                self.items.append(None)
        def move_bag(self, bag, target):
            pass


        def has(self, items):
            if not isinstance(items, list):
                items = [items]
            for i in items:
                for j in self.items:
                    if j:
                        if i.item == j.item:
                            if j.quantity < i.quantity:
                                return False
                            else:
                                pass
                else:
                    return False
            else:
                return True

        def got(self, items, uniqueID = None, announce = True):
            rejects = []
            if uniqueID and uniqueID in self.uniqueID:
                if announce:
                    msg.msg("Already got that.")
            if not isinstance(items, list):
                items = [items]
            for i in items:
                if isinstance(i, int):
                    self.cash += i
                else:
                    for j in self.items:
                        if j:
                            if j.item == i.item:
                                j.quantity += i.quantity
                                if announce:
                                    msg.msg("Got {} of {}.".format(i.quantity, i.item.name))
                                break
                    else:
                        for n,k in enumerate(self.items):
                            if k == None:
                                self.items[n] = i
                                msg.msg("Got {} of {}.".format(i.quantity, i.item.name))
                                break
                        else:
                            rejects.append(i)
                            if announce:
                                msg.msg("Bags are full.")
            # return rejects

        def give(self, items, recipient):
            if not isinstance(items, list):
                items = [items]
            pass

        def drop(self, items, announce = True):
            if not isinstance(items, list):
                items = [items]
            for i in items:
                for j in self.items:
                    if j:
                        if j.item == i.item:
                            if j.quantity > i.quantity:
                                j.quantity -= i.quantity
                                break
                            elif j.quantity == i.quantity:
                                j = None
                                break
                            else:
                                pass
                else:
                    pass

        def clicked(self, index):
            self.holding, self.items[index] = self.items[index], self.holding



screen inventory(inv, items):
    modal True
    style_prefix "inventory"
    drag:
        align .5,.5
        frame:
            padding 10,10 background Frame("inventory/icons/empty.png", 10,10)
            xsize 40+(128*5)
            vbox:
                hbox: # Bags
                    xfill True
                    hbox:
                        for n, i in enumerate(inv.bags):
                            button:
                                text i[1]
                                action Function(inv.set_bag, n), SelectedIf(inv.current_bag[2] == n)
                    text str(inv.cash) align 1.0,.5
                hbox:
                    box_wrap True spacing 4 box_wrap_spacing 4
                    for i in range(inv.current_bag[0], inv.current_bag[1]):
                        button: # Item
                            xysize 128,128 padding 0,0 background None
                            action Function(inv.clicked, i)
                            if inv.items[i]:
                                tooltip inv.items[i]
                                fixed:
                                    add inv.items[i].item.icon
                                    # text inv.items[i].item.name size 20
                                    text str(inv.items[i].quantity) size 20 align 1.,1.0 offset -8,-8 outlines [( 2, "#fff", 0, 0)]
                            else:
                                add "inventory/icons/empty.png"

    # Holding
    default mouse = (0,0)
    if inv.holding:
        timer 0.02 repeat True action SetScreenVariable("mouse", renpy.get_mouse_pos())
        frame:
            xysize 128,128 pos mouse padding 0,0 background None
            at holding_item_anim
            fixed:
                add inv.holding.item.icon
                # text inv.holding.item.name size 20
                if inv.holding.quantity > 1:
                    text str(inv.holding.quantity) size 20 align 1.,1.0 offset -8,-8 outlines [( 2, "#fff", 0, 0)]

    drag: # Tests
        pos 100,100
        frame:
            vbox:
                text "Tests"
                button:
                    text "Add item"
                    action Function(inv.got, stack(renpy.random.choice(items), 1))
                button:
                    text "Add items"
                    action Function(inv.got, [stack(items[0], 1), stack(items[1], 1), stack(items[2], 1), stack(items[3], 1), stack(items[4], 1), stack(items[5], 1)])

                button:
                    text "Add Money"
                    action Function(inv.got, renpy.random.randint(0,100))
                button:
                    text "Add bag"
                    action Function(inv.add_bag, [5, "test"])



style inventory_text:
    color "#000"
style inventory_frame:
    background "#fffa"
    padding (10,10)
style inventory_button:
    background "#fffa"
    hover_background "#fff"
    selected_background "#affa"
    padding (10,10)
style inventory_hbox:
    spacing 4
style inventory_vbox:
    spacing 4

transform holding_item_anim:
    alpha 0
    pause .05
    ease .1 alpha 1

