﻿init python:
    class item: # Item class
        def __init__(self,
                name, info = "No description", icon = "inventory/icons/empty.png", value = 0,
                tags = [], waste = []
            ):
            self.name = name
            self.info = info
            self.icon = icon
            self.value = value
            self.tags = tags
            self.waste = waste

    class stack: # Item stack class
        def __init__(self, item, quantity):
            self.item = item
            self.quantity = quantity
        
        def sum(self): # Returns the total value for the items in this stack
            return self.item.value*self.quantity




    class food(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                food = 0, water = 0,
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.food = food
            self.water = water

    class book(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                text = [],
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.text = text

    class equipment(item):
        def __init__(self,
                name, info = "No description", icon = "inventory/empty.png", value = 0,
                tags = [], waste = [],
                weight = 0
            ):
            item.__init__(self, name, info, icon, value, tags, waste)
            self.weight = weight


















